/**
 * @file
 * Provides SlickLightbox loader.
 */

(function ($, Drupal, drupalSettings) {

  "use strict";

  /**
   * SlickLightbox utility functions.
   *
   * @param {int} i
   *   The index of the current element.
   * @param {HTMLElement} elm
   *   The SlickLightbox HTML element.
   */
  function doSlickLightbox(i, elm) {
    var t = $(elm);

    var options = {
      // @todo use [data-slick-lightbox-trigger] post Blazy 1.x update/ release.
      itemSelector: 'a.litebox',
      caption: function (element, info) {
        return $(element).next('.litebox-caption').length ? $(element).next('.litebox-caption').html() : '';
      },
      slick: drupalSettings.slickLightbox || {}
    };

    t.slickLightbox(options);
  }

  /**
   * Attaches slick-lightbox behavior to HTML element.
   *
   * @type {Drupal~behavior}
   */
  Drupal.behaviors.slickLightbox = {
    attach: function (context) {
      // @todo remove the BC once Blazy updated.
      $("[data-slick-lightbox-gallery]", context).once("slick-lightbox").each(doSlickLightbox);
    }
  };

})(jQuery, Drupal, drupalSettings);
